Menu (Java Platform SE 8 )
Keywords: java.awt.Menu class
Date: 2015-05-24

java.awt

## Class Menu

- java.lang.Object
- - java.awt.MenuComponent
  - - java.awt.MenuItem
    - - java.awt.Menu

- All Implemented Interfaces:
    MenuContainer, Serializable, Accessible
  Direct Known Subclasses:
    PopupMenu

      public class Menu
      extends MenuItem
      implements MenuContainer, Accessible

  A `Menu` object is a pull-down menu component that is deployed from a menu bar.

  A menu can optionally be a tear-off menu. A tear-off menu can be opened and dragged away from its parent menu bar or menu. It remains on the screen after the mouse button has been released. The mechanism for tearing off a menu is platform dependent, since the look and feel of the tear-off menu is determined by its peer. On platforms that do not support tear-off menus, the tear-off property is ignored.

  Each item in a menu must belong to the `MenuItem` class. It can be an instance of `MenuItem`, a submenu (an instance of `Menu`), or a check box (an instance of `CheckboxMenuItem`).

  Since:
    JDK1.0
  See Also:
    `MenuItem`, `CheckboxMenuItem`, Serialized Form

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `protected class` | `Menu.AccessibleAWTMenu` Inner class of Menu used to provide default support for accessibility.

    - ### Nested classes/interfaces inherited from class java.awt.MenuItem

      `MenuItem.AccessibleAWTMenuItem`

    - ### Nested classes/interfaces inherited from class java.awt.MenuComponent

      `MenuComponent.AccessibleAWTMenuComponent`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Menu()` Constructs a new menu with an empty label.
    `Menu(String label)` Constructs a new menu with the specified label.
    `Menu(String label, boolean tearOff)` Constructs a new menu with the specified label, indicating whether the menu can be torn off.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `MenuItem` | `add(MenuItem mi)` Adds the specified menu item to this menu.
    `void` | `add(String label)` Adds an item with the specified label to this menu.
    `void` | `addNotify()` Creates the menu's peer.
    `void` | `addSeparator()` Adds a separator line, or a hypen, to the menu at the current position.
    `int` | `countItems()` Deprecated. As of JDK version 1.1, replaced by `getItemCount()`.
    `AccessibleContext` | `getAccessibleContext()` Gets the AccessibleContext associated with this Menu.
    `MenuItem` | `getItem(int index)` Gets the item located at the specified index of this menu.
    `int` | `getItemCount()` Get the number of items in this menu.
    `void` | `insert(MenuItem menuitem, int index)` Inserts a menu item into this menu at the specified position.
    `void` | `insert(String label, int index)` Inserts a menu item with the specified label into this menu at the specified position.
    `void` | `insertSeparator(int index)` Inserts a separator at the specified position.
    `boolean` | `isTearOff()` Indicates whether this menu is a tear-off menu.
    `String` | `paramString()` Returns a string representing the state of this `Menu`.
    `void` | `remove(int index)` Removes the menu item at the specified index from this menu.
    `void` | `remove(MenuComponent item)` Removes the specified menu item from this menu.
    `void` | `removeAll()` Removes all items from this menu.
    `void` | `removeNotify()` Removes the menu's peer.

    - ### Methods inherited from class java.awt.MenuItem

      `addActionListener, deleteShortcut, disable, disableEvents, enable, enable, enableEvents, getActionCommand, getActionListeners, getLabel, getListeners, getShortcut, isEnabled, processActionEvent, processEvent, removeActionListener, setActionCommand, setEnabled, setLabel, setShortcut`

    - ### Methods inherited from class java.awt.MenuComponent

      `dispatchEvent, getFont, getName, getParent, getPeer, getTreeLock, postEvent, setFont, setName, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface java.awt.MenuContainer

      `getFont, postEvent`

- - ### Constructor Detail

    - #### Menu

          public Menu()
               throws HeadlessException

      Constructs a new menu with an empty label. This menu is not a tear-off menu.
      Throws:
        `HeadlessException` - if GraphicsEnvironment.isHeadless() returns true.
      Since:
        JDK1.1
      See Also:
        `GraphicsEnvironment.isHeadless()`

    - #### Menu

          public Menu(String label)
               throws HeadlessException

      Constructs a new menu with the specified label. This menu is not a tear-off menu.
      Parameters:
        `label` - the menu's label in the menu bar, or in another menu of which this menu is a submenu.
      Throws:
        `HeadlessException` - if GraphicsEnvironment.isHeadless() returns true.
      See Also:
        `GraphicsEnvironment.isHeadless()`

    - #### Menu

          public Menu(String label,
                      boolean tearOff)
               throws HeadlessException

      Constructs a new menu with the specified label, indicating whether the menu can be torn off.

      Tear-off functionality may not be supported by all implementations of AWT. If a particular implementation doesn't support tear-off menus, this value is silently ignored.

      Parameters:
        `label` - the menu's label in the menu bar, or in another menu of which this menu is a submenu.
        `tearOff` - if `true`, the menu is a tear-off menu.
      Throws:
        `HeadlessException` - if GraphicsEnvironment.isHeadless() returns true.
      Since:
        JDK1.0.
      See Also:
        `GraphicsEnvironment.isHeadless()`

  - ### Method Detail

    - #### addNotify

          public void addNotify()

      Creates the menu's peer. The peer allows us to modify the appearance of the menu without changing its functionality.
      Overrides:
        `addNotify` in class `MenuItem`

    - #### removeNotify

          public void removeNotify()

      Removes the menu's peer. The peer allows us to modify the appearance of the menu without changing its functionality.
      Overrides:
        `removeNotify` in class `MenuComponent`

    - #### isTearOff

          public boolean isTearOff()

      Indicates whether this menu is a tear-off menu.

      Tear-off functionality may not be supported by all implementations of AWT. If a particular implementation doesn't support tear-off menus, this value is silently ignored.

      Returns:
        `true` if this is a tear-off menu; `false` otherwise.

    - #### getItemCount

          public int getItemCount()

      Get the number of items in this menu.
      Returns:
        the number of items in this menu.
      Since:
        JDK1.1

    - #### countItems

          @Deprecated
          public int countItems()

      Deprecated. As of JDK version 1.1, replaced by `getItemCount()`.

    - #### getItem

          public MenuItem getItem(int index)

      Gets the item located at the specified index of this menu.
      Parameters:
        `index` - the position of the item to be returned.
      Returns:
        the item located at the specified index.

    - #### add

          public MenuItem add(MenuItem mi)

      Adds the specified menu item to this menu. If the menu item has been part of another menu, removes it from that menu.
      Parameters:
        `mi` - the menu item to be added
      Returns:
        the menu item added
      See Also:
        `insert(java.lang.String, int)`, `insert(java.awt.MenuItem, int)`

    - #### add

          public void add(String label)

      Adds an item with the specified label to this menu.
      Parameters:
        `label` - the text on the item
      See Also:
        `insert(java.lang.String, int)`, `insert(java.awt.MenuItem, int)`

    - #### insert

          public void insert(MenuItem menuitem,
                             int index)

      Inserts a menu item into this menu at the specified position.
      Parameters:
        `menuitem` - the menu item to be inserted.
        `index` - the position at which the menu item should be inserted.
      Throws:
        `IllegalArgumentException` - if the value of `index` is less than zero
      Since:
        JDK1.1
      See Also:
        `add(java.lang.String)`, `add(java.awt.MenuItem)`

    - #### insert

          public void insert(String label,
                             int index)

      Inserts a menu item with the specified label into this menu at the specified position. This is a convenience method for `insert(menuItem, index)`.
      Parameters:
        `label` - the text on the item
        `index` - the position at which the menu item should be inserted
      Throws:
        `IllegalArgumentException` - if the value of `index` is less than zero
      Since:
        JDK1.1
      See Also:
        `add(java.lang.String)`, `add(java.awt.MenuItem)`

    - #### addSeparator

          public void addSeparator()

      Adds a separator line, or a hypen, to the menu at the current position.
      See Also:
        `insertSeparator(int)`

    - #### insertSeparator

          public void insertSeparator(int index)

      Inserts a separator at the specified position.
      Parameters:
        `index` - the position at which the menu separator should be inserted.
      Throws:
        `IllegalArgumentException` - if the value of `index` is less than 0.
      Since:
        JDK1.1
      See Also:
        `addSeparator()`

    - #### remove

          public void remove(int index)

      Removes the menu item at the specified index from this menu.
      Parameters:
        `index` - the position of the item to be removed.

    - #### remove

          public void remove(MenuComponent item)

      Removes the specified menu item from this menu.
      Specified by:
        `remove` in interface `MenuContainer`
      Parameters:
        `item` - the item to be removed from the menu. If `item` is `null` or is not in this menu, this method does nothing.

    - #### removeAll

          public void removeAll()

      Removes all items from this menu.
      Since:
        JDK1.0.

    - #### paramString

          public String paramString()

      Returns a string representing the state of this `Menu`. This method is intended to be used only for debugging purposes, and the content and format of the returned string may vary between implementations. The returned string may be empty but may not be `null`.
      Overrides:
        `paramString` in class `MenuItem`
      Returns:
        the parameter string of this menu

    - #### getAccessibleContext

          public AccessibleContext getAccessibleContext()

      Gets the AccessibleContext associated with this Menu. For menus, the AccessibleContext takes the form of an AccessibleAWTMenu. A new AccessibleAWTMenu instance is created if necessary.
      Specified by:
        `getAccessibleContext` in interface `Accessible`
      Overrides:
        `getAccessibleContext` in class `MenuItem`
      Returns:
        an AccessibleAWTMenu that serves as the AccessibleContext of this Menu
      Since:
        1.3

Submit a bug or feature
For further API reference and developer documentation, see Java SE Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.
Copyright © 1993, 2015, Oracle and/or its affiliates. All rights reserved.